#include <cassert>

#include <cstdlib>
using std::atoi;
using std::exit;

#include <algorithm>
using std::max;

#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include "routines.h"

void keyboard(unsigned char key, int x, int y)
{
	if (key == 'q') exit(0);
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT);
	glBegin(GL_LINE_STRIP);
	glColor3f(1.0,1.0,1.0);
	double cmx,cmy;
	long int wx,wy;
	thePolymer.query_dimensions(cmx,cmy,wx,wy);
	for (polymer::const_iterator step = thePolymer.begin(); step < thePolymer.end(); ++step)
	{
		const long int w = max(wx,wy);
		assert(w > 0);
		const double x = (step->x - cmx)/w;
		const double y = (step->y - cmy)/w;
		glVertex2f(x,y);
	}
	glEnd();
	glFlush();
	glutSwapBuffers();
}

int delay;
void animate(int)
{
	update();
	glutPostRedisplay();
	glutTimerFunc(delay,animate,0);
}

int main(int argc, char* argv[])
{
	assert(argc == 2);
	const size_t L = atoi(argv[1]);
	assert(L != 0);
	initialize(L);
	delay = max(int(5000/thePolymer.size()),1);

	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
	glutInitWindowSize(640, 640);
	glutInitWindowPosition(100, 100);
	glutCreateWindow("Polymer");
	glutKeyboardFunc(keyboard);	
	glutDisplayFunc(display);
	glutTimerFunc(delay,animate,0);
	glutMainLoop();
}
